// 002 u_c_genc_407_linked_ienumerable_list
// 03 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_genc_407_linked_ienumerable_list;
  interface
    uses System.Collections
         , System.Collections.Generic;

    type cg_cell<T> =
             class(System.Object  )
               m_first_name: T;
               m_c_next_cell: cg_cell<T>;

               constructor create_cell(p_first_name: T; p_c_next_cell: cg_cell<T>);
             end; // c_find_list

         cig_cell_enumerator<T>=
             class(tObject, iEnumerator< cg_cell<T> >, iDisposable)
                 private
                   m_c_current_cell: cg_cell<T>;
                   m_c_previous_cell: cg_cell<T>;
                 strict private
                   function IEnumerator.get_Current = get_CurrentObject;
                   function get_CurrentObject: TObject;
                 public
                   function get_Current: cg_cell<T>;
                   constructor create_cell_enumerator(p_c_first_cell: cg_cell<T> );

                   function MoveNext: Boolean;
                   procedure Reset;
                   procedure Dispose; virtual;

                   property Current: cg_cell<T> read get_Current;
               end; // cig_cell_enumerator

         cg_list<T: cg_cell<T> >=
             class(System.Object, iEnumerable<cg_cell<T> > )
               private
                 m_c_first_cell: cg_cell<T>;
               public
                 constructor create_list;

                 function GetEnumerator: iEnumerator;
                 // -- is private
                 function getEnumeratorT: iEnumerator<cg_cell<T> >;
                 function iEnumerable<cg_cell<T> >.GetEnumerator = GetEnumeratorT;
             end; // c_find_list

  implementation

    // -- cg_cell<T>

    constructor cg_cell<T>.create_cell(p_first_name: T; p_c_next_cell: cg_cell<T>);
      begin
        Inherited Create;

        m_first_name:= p_first_name;
        m_c_next_cell:= p_c_next_cell;
      end; // create_cell

    // -- cig_cell_enumerator<T>

    constructor cig_cell_enumerator<T>.create_cell_enumerator(p_c_first_cell: cg_cell<T> );
      begin
        Inherited Create;

        m_c_current_cell:= p_c_first_cell;
      end; // create_cell_enumerator

    function cig_cell_enumerator<T>.Get_Current: cg_cell<T>;
      begin
        Result:= m_c_previous_cell;
      end; // GetCurrent

    function cig_cell_enumerator<T>.get_CurrentObject: TObject;
      begin
        raise NotSupportedException.Create;
      end; // get_CurrentObject

    function cig_cell_enumerator<T>.MoveNext: Boolean;
      begin
        m_c_previous_cell:= m_c_current_cell;

        Result:= m_c_previous_cell<> Nil;
        if Result
          then m_c_current_cell:= m_c_current_cell.m_c_next_cell
      end; // MoveNext

    procedure cig_cell_enumerator<T>.Reset;
      begin
        raise NotSupportedException.Create;
      end; // reset

    procedure cig_cell_enumerator<T>.Dispose;
      begin
        raise NotSupportedException.Create;
      end; // Dispose

    // --  cg_list<T>

    constructor cg_list<T>.create_list;
      begin
        Inherited Create;
      end; // create_list

    function cg_list<T>.GetEnumerator: iEnumerator;
      begin
        raise NotSupportedException.Create;
      end; // GetEnumerator

    function cg_list<T>.getEnumeratorT: iEnumerator<cg_cell<T> >;
      var l_cig_cell_enumerator: cig_cell_enumerator<T>;
      begin
        l_cig_cell_enumerator:= cig_cell_enumerator<T>.create_cell_enumerator(m_c_first_cell);
      end; // getEnumeratorT

  end.


